﻿using System;
using System.Windows.Data;

namespace SQLDataTransferer.Converters
{
    public class RadioButtonCheckedConverter : IValueConverter
    {
        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value == null ||
                parameter == null)
                return false;

            string checkValue = value.ToString().ToLower();
            string targetValue = parameter.ToString().ToLower();
            return checkValue.Equals(targetValue,
                     StringComparison.InvariantCultureIgnoreCase);
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value == null ||
                parameter == null)
                return null;

            bool useValue = (bool)value;
            string targetValue = parameter.ToString();
            if (useValue)
                return Enum.Parse(targetType, targetValue);

            return null;
        }

        #endregion
    }
}
